ST@RT    CSECT
ENTRYREG EQU   15
INDEXREG EQU   14
RETREG   EQU   14
LOCALREG EQU   13
COMREG   EQU   12
CODEREG  EQU   11
PARAMREG EQU   10
BASEREG  EQU   9
         LR    11,15
         USING ST@RT,11
         LR    12,14
         L     0,GETLV
         GETMAIN R,LV=(0)
         ST    12,SR15-SAVE(1)
         ST    13,OLD-SAVE(1)
         ST    1,NEW-SAVE(13)
         LR    13,1
         LR    12,1
         USING SYSCOM,12
         SR    0,0
         ST    0,0(13)
         ST    0,STAKBOT-STARTUP+LASTAREA-STAKDESC(13)
         ST    0,STAKBOT-STARTUP+NEXTAREA-STAKDESC(13)
         ST    0,STAKBOT-STARTUP+NEXTADDR-STAKDESC(13)
         ST    0,STAKBOT-STARTUP+NEXTLEN-STAKDESC(13)
         ST    0,RETCODE
         LA    0,STAKBOT
         ST    0,ST@CK-SAVE+SYSCOM
         ST    0,ST@CK-SAVE+SYSCOM+4
*           DEFAULT PARAMETERS
         MVC   PH,=X'00FFFFF8'
         MVC   PR,=X'00005000'
         MVC   PL,PR
*           OBTAIN PARM LIST
         L     2,OLD-SAVE(13)      OLD SAVE AREA
         L     2,SR1-SAVE(2)       REG 1 FROM OLD SAVE AREA
         ST    2,OSPARAM
         L     2,0(2)         ADDRESS OF FIRST PARAMETER
         LH    3,0(2)         LENGTH OF JCL PARM STRING
         LA    2,2(2)         START OF JCL PARM STRING
         ST    3,OSPARML
         ST    2,OSPARMA
*      SHOULD WE REQUIRE A $ BEFORE SYSPARM
*      BECAUSE IT IS HARDLY EVER NEEDED?
         SR    1,1
         SPM   1
PARMLOOP LTR   3,3
         BNH   EOPARM
         CLI   0(2),C'/'
         BE    PSLASH
         CLI   0(2),C';'
         BE    PSLASH
         CLI   0(2),C'L'
         BE    LDL
         CLI   0(2),C'L'-64
         BE    LDL
         CLI   0(2),C'H'
         BE    LDH
         CLI   0(2),C'H'-64
         BE   LDH
         CLI   0(2),C'R'
         BE    LDR
         CLI   0(2),C'R'-64
         BE    LDR
         CLI   0(2),C','
         BE    PNEXT
*           IF THERE ARE TO BE MORE OPTIONS,
*           ADD THEM HERE.
PNEXT    LA    2,1(2)
         BCTR  3,0
         B     PARMLOOP
LDL      LA    5,PL
         B     RDNUM
LDR      LA    5,PR
         B     RDNUM
LDH      LA    5,PH
         B     RDNUM
PSLASH   LA    2,1(2)         REST OF PARM STRING IS FOR USER.
         BCTR  3,0
         B     EOPARM
*           READ NUMERICAL PARAMETER
RDNUM    CLI   1(2),C'='
         BNE   PNEXT
         LA    2,2(2)
         S     3,=F'2'
         SR    1,1
         SR    4,4
RDNML    CLI   0(2),C'0'
         BL    ENNUMK
         CLI   0(2),C'9'
         BH    ENNUMK
         IC    4,0(2)
         SH    4,=H'240'
         M     0,=F'10'
         SLDA  0,32
         BNO   *+8
         L     0,=X'7FFFFFFF'
         LR    1,0
         AR    1,4
         BNO   *+8
         L     1,=X'7FFFFFFF'
         LA    2,1(2)
         BCT   3,RDNML
         B     ENNUM
ENNUMK   CLI   0(2),C'K'
         BE    ENNUMKK
         CLI   0(2),C'K'-64
         BNE   ENNUM
ENNUMKK  SLA   1,12
         BNO   *+8
         L     1,=X'7FFFFFFF'
         LA    2,1(2)
         BCTR  3,0
ENNUM    ST    1,0(5)
         B     PARMLOOP
EOPARM   DS    0H
         ST    2,USPARMA       USER PARM LIST ADDRESS
         ST    3,USPARML                      LENGTH
         ICM   2,8,=B'00001110'
         SPM   2
         L     15,SR15-SAVE(13)
         BALR  14,15
*
         L     1,OLD-SAVE(13)
         L     1,SR14-SAVE(1)
         SPM   1
*    FIND END OF AREA DESCRIPTOR CHAIN
         LA    1,STAKBOT
LOOPALOC LR    2,1
         L     1,NEXTAREA-STAKDESC(2)
         LTR   1,1
         BNZ   LOOPALOC
*         ASSERT  NEXTAREA-STAKDESC(2) = 0
*    FREE STACK SEGMENTS.
FREEDO   L     2,LASTAREA-STAKDESC(2)
         LTR   2,2
         BZ    FREEOD
         FREEMAIN V,A=NEXTADDR-STAKDESC(2),SP=4,MF=(E,GETTER)
         B     FREEDO
FREEOD   DS    0H
*    FREE SYSCOM AND RETURN
         L     3,RETCODE
         LR    1,13
         L     13,OLD-SAVE(13)
         FREEMAIN R,A=(1),LV=STARTUPL,SP=4
         LR    15,3
         RETURN (14,12),T,RC=(15)
         DROP
         DS    F
GETLV    DC    X'04'
         DC    AL3(STARTUPL)
         ENTRY ST@KOFLO
*
*           ALLOCATE STORAGE
*           NORMALLY DONE ONLY ONCE.
*
         USING SYSCOM,12
*           ON ENTRY:
*              R2 = ADDR OF STACK TOP + CURRENT REQUEST
*              R3 = LIMIT OF CURRENT STACK SECTOR
*                 -> ST@KAREA
*              R2 = R3 -> STAKBOT  IF NO STACK SEGMENTS EXIST.
*              R4 = CURRENT REQUEST
*              R12 -> SYSCOM
*
         USING ST@KOFLO,15
ST@KOFLO B     STAKAR
         DC    AL1(8)
         DC    C'ST@KOFLO'
STAKAR   STM   14,12,STAKSAVE+SR14-SAVE
         LA    11,STAKSAVE
         ST    11,8(13)
         ST    13,4(11)
         LA    13,STAKSAV2
         ST    11,4(13)
         ST    13,8(11)
         DROP  15
         LR    11,15
         USING ST@KOFLO,11
         MVC   GETTER(GETTERL),OGETTER
         C     2,NEXTLEN-STAKDESC(3)
         BH    MUSTGET
         L     4,NEXTADDR-STAKDESC(3)
         LR    13,4
         L     3,NEXTAREA-STAKDESC(3)
         AR    4,2
         B     RETOFLO
*
MUSTGET  DS    0H
*    COMPUTE GETMAIN PARAMETERS FROM L, H, AND R.
         L     5,PR
         LA    5,STAKARL(2,5)
         L     2,PL
         CR    2,5
         BNL   *+6
         LR    2,5
         C     2,=X'00FFFFF8'
         BNH   *+8
         L     2,=X'00FFFFF8'
         LA    2,7(2)
         N     2,=X'00FFFFF8'
         ST    2,GETMIN
         L     5,PH
         CR    2,5
         BNL   *+6
         LR    2,5
         C     2,=X'00FFFFF8'
         BNH   *+8
         L     2,=X'00FFFFF8'
         LA    2,7(2)
         N     2,=X'00FFFFF8'
         ST    2,GETMAX
         GETMAIN VU,LA=GETMIN,A=GOTADDR,SP=4,BNDRY=DBLWD,MF=(E,GETTER)
         L     0,PR
         L     1,GOTADDR
         LR    2,1
         AR    2,0
         ST    2,GOTADDR
         L     2,GOTLEN
         SR    2,0
         ST    2,GOTLEN
         ICM   0,8,=X'04'       SUBPOOL NUMBER
         FREEMAIN R,LV=(0),A=(1)
*               GOTADDR AND GOTLEN NOW DESCRIBE NEWLY ALLOCATED AREA.
         L     2,GOTADDR
         L     5,GOTLEN
         AR    5,2
*    DEDUCT AREA DESCRIPTOR.
         S     5,=A(STAKARL)
*           INSERT NEW AREA INTO CHAIN
         L     6,NEXTAREA-STAKDESC(3)
*           R2 -> NEW AREA
*           R3 -> AREA DESCRIPTOR IN CURRENT AREA
*                    DESCRIBES OLD NEXT AREA, IF ANY
*                    WILL DESCRIBE NEW AREA
*              = CURRENT AREA LIMIT
*           R5 = AREA DESCRIPTOR IN NEW AREA
*                    WILL DESCRIBE OLD NEXT AREA, IF ANY.
*           R6 = AREA DESCRIPTOR IN OLD NEXT AREA, IF ANY.
         MVC   NEXTADDR-STAKDESC(8,5),NEXTADDR-STAKDESC(3)
         MVC   NEXTADDR-STAKDESC(8,3),GOTADDR
         ST    6,NEXTAREA-STAKDESC(5)
         ST    5,NEXTAREA-STAKDESC(3)
         ST    3,LASTAREA-STAKDESC(5)
         LTR   6,6
         BZ    NOOLDNXT
         ST    5,0(6)
NOOLDNXT DS    0H
         LR    3,5
         LR    14,10
         LR    4,2
         LR    13,2
         L     2,SR2-SAVE+STAKSAVE
         AR    4,2
RETOFLO  LM    14,1,STAKSAVE+SR14-SAVE
         LM    5,12,STAKSAVE+SR5-SAVE
         BR    14
OGETTER  GETMAIN MF=L
         ENTRY @EXIT
@EXIT    LR    13,12
         RETURN (14,12),T
         DROP
         LTORG
*
STAKDESC DSECT
LASTAREA DS    F    POINTS TO LAST STAKDESC OR IS 0
NEXTAREA DS    F    POINTS TO NEXT STAKDESC OR IS 0
NEXTADDR DS    F    ADDR AND LEN FOR A FREEMAIN. VALID ONLY
NEXTLEN  DS    F        IF NEXTAREA /= 0
*                FURTHERMORE, NEXTAREA + NEXTLEN = NEXTADDR + STAKARL
STAKARL  EQU   *-STAKDESC
*
SAVE     DSECT
PL1      DS    F
OLD      DS    F
NEW      DS    F
SR14     DS    F
SR15     DS    F
SR0      DS    F
SR1      DS    F
SR2      DS    F
SR3      DS    F
SR4      DS    F
SR5      DS    F
SR6      DS    F
SR7      DS    F
SR8      DS    F
SR9      DS    F
SR10     DS    F
SR11     DS    F
SR12     DS    F
ST@CK    DS    2F
SAVEL    EQU   *-SAVE
*
STARTUP  DSECT
SYSCOM   EQU   STARTUP
         DS    CL(SAVEL)
OSPARAM  DS    F
OSPARML  DS    F
OSPARMA  DS    F
PL       DS    F
PH       DS    F
PR       DS    F
USPARML  DS    F
USPARMA  DS    F
RETCODE  DS    F
GETTER   GETMAIN MF=L
GETTERL  EQU   *-GETTER
GETMIN   DS    F
GETMAX   DS    F
GOTADDR  DS    F
GOTLEN   DS    F
STAKBOT  DS    CL(STAKARL)
EXTADDR  DS    F
EXTLEN   DS    F
         DS    0D
STAKSAVE DS    CL(SAVEL)
STAKSAV2 DS    CL(SAVEL)
         DS    0D
STARTUPL EQU   *-STARTUP
         END
